require 'soar/policy/access_manager/model_provider/policy'
require 'soar/policy/access_manager/model'
require 'jsender'
require 'uri'
require 'ostruct'

module Soar
  module Policy
    module AccessManager
      module Test
        module OrchestrationProvider
          class Policy

            ##
            # for a specific path and service
            # I want to tell the access manager to query a specific url and paramaters for a policy
            # service_identifier = service_name in router
            # resource_identifier = path in router
            ##
            def initialize
              policy_host = ENV['POLICY_HOST'] || 'localhost:8080'
              @meta = {
                'service_identifier1' => 'allow_policy',
                'service_identifier2' => 'deny_policy'
              }
              @policies = {
                'allow_policy' => "http://#{policy_host}/allow",
                'deny_policy' => "http://#{policy_host}/deny"
              }
              @request = {
                authentication_identifier: 'authentication_identifier1',
                params: {},
              }
              @resource_identifier = 'resource_identifier1'
            end

            def grant_access
              @service_identifier = 'service_identifier1'
            end

            def deny_access
              @service_identifier = 'service_identifier2'
            end

            def no_policy
              @service_identifier = 'service_identifier3'
            end

            def notification
              @response['data']['notifications']
            end

            def authorized?
              model_provider = Soar::Policy::AccessManager::ModelProvider::Policy.new(meta: @meta, policies: @policies )
              model = Soar::Policy::AccessManager::Model.new(model_provider)
              @response = model.authorized?(service_identifier: @service_identifier, resource_identifier: @resource_identifier, request: @request)
            end

            def authorized
              @response['data']['approved']
            end

          end
        end
      end
    end
  end
end
